/***************************************************************************
*   Copyright (C) 2004 by Denis A. Birukov aka Messenger of death         *
*   riper@fromru.com                                                      *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/
#ifndef me_n_storage_driver_interface_h
#define me_n_storage_driver_interface_h
#include <me_defines.h>
#include <string>
#include <map>
#include <iostream>
namespace ME_n_Storage
{

	/**
	         (ME_c_Storage).
	      .
	      ,      .
	     .

	@author Denis A. Birukov aka Messenger of death 
	*/
	class ME_c_Parser;
	class ME_c_Storage;
	class ME_c_Storage_Driver_Interface
	{
			std::string _driver_name_;
		public:
			/**      */
			ME_c_Storage_Driver_Interface( std::string name ) : _driver_name_( name )
			{}
			DECLSPEC virtual ~ME_c_Storage_Driver_Interface()
			{}
			/**     */
			DECLSPEC const std::string _get_driver_name()
			{
				return _driver_name_;
			}
			/**          .*/
			DECLSPEC virtual bool _parse_stream( std::istream &stream, std::map<std::string, ME_c_Parser*>, ME_c_Storage* storage ) = 0;

	};

}

#endif
