/***************************************************************************
*   Copyright (C) 2004 by Denis A. Birukov aka Messenger of death         *
*   riper@fromru.com                                                      *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/ 
/*
*        .    *   
*/

#ifndef ME_C_VIDEOME_C_VIDEO_H
#define ME_C_VIDEOME_C_VIDEO_H
#include <me_defines.h>
#include <string>

namespace ME_n_Video
{
	/**
	     .
	 
	@author Denis A. Birukov aka Messenger of death 
	*/
	class ME_c_Video_Driver_Interface;
	class ME_c_Video_Features;
	class ME_c_Video
	{
		public:
			ME_c_Video() {}
			~ME_c_Video() {}
			/**    */
			DECLSPEC bool _init_video( ME_c_Video_Driver_Interface* drv );
			/**      */
			DECLSPEC bool _init_video( std::string name );
			/**   ME_c_Video_Features,     */
			DECLSPEC ME_c_Video_Features _get_features();
			/**       */
			DECLSPEC void _deinit_video();
			/**   */
			DECLSPEC std::string _get_driver_name();
			/**    */
			DECLSPEC ME_c_Video_Driver_Interface& operator->();
			/**    */
			DECLSPEC ME_c_Video_Driver_Interface& operator*();
	};
}




#endif
