/***************************************************************************
*   Copyright (C) 2004 by Denis A. Birukov aka Messenger of death         *
*   riper@fromru.com                                                      *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/
#ifndef ME_N_STORAGEME_C_STORAGE_DRIVER_CFG_H
#define ME_N_STORAGEME_C_STORAGE_DRIVER_CFG_H

#include <me_defines.h>
#include <string>
#include <map>
#include <iostream>
#include <vector>
#include <utility>
#include <me_c_storage_driver_interface.h>

namespace ME_n_Storage
{

	class ME_c_Storage;
	class ME_c_Parser;
	/**
	    .
	       [name]  [/name]([/])
	        ValueName Value        .
	ValueName - ,  
	    '/  '
	  .
	 .

	@author Denis A. Birukov aka Messenger of death 
	*/
	class ME_c_Storage_Driver_CFG : public ME_c_Storage_Driver_Interface
	{
		public:
			ME_c_Storage_Driver_CFG(): ME_c_Storage_Driver_Interface( "SimpleTextCFGDriver" )
			{}
			virtual ~ME_c_Storage_Driver_CFG()
			{}
			/**          .*/
			DECLSPEC bool _parse_stream( std::istream& stream, std::map< std :: string, ME_c_Parser * > arg1, ME_c_Storage* storage );

	};  

	extern "C" DECLSPEC ME_c_Storage_Driver_Interface* _create_storage_driver();

}

#endif
