/***************************************************************************
*   Copyright (C) 2004 by Denis A. Birukov aka Messenger of death         *
*   riper@fromru.com                                                      *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/
#ifndef ME_N_LOGME_C_LOG_H
#define ME_N_LOGME_C_LOG_H
#include <me_defines.h>
#include <string>
#include <iostream>
#include <me_c_log_interface.h>
namespace ME_n_Log
{
	class ME_c_Log_Interface;
	enum ME_DEBUG_LEVEL
	{
	    ME_DEBUG_FATAL = 250,
	    ME_DEBUG_ERROR = 220,
	    ME_DEBUG_WARNING = 200,
	    ME_DEBUG_INFO = 10
	};

	/**        */
	DECLSPEC void _set_debug_priority( Uint8 );
	/**        */
	DECLSPEC void _init_debug( ME_c_Log_Interface *lg );
	/**  */
	DECLSPEC void _debug( std::string, Uint8 priority );
	DECLSPEC ME_c_Log_Interface& _debug( Uint8 );
	DECLSPEC ME_c_Log_Interface& _debug();
}

#endif
